package	jp.co.sds_corp.nanchart.graph;

import java.awt.Rectangle;

/**
Stack100Storageは、100%積み上げグラフのためのデータ格納クラスです。
<BR>
実際の値はオブジェクトの配列に格納されます。
*/
public class Stack100Storage extends StackStorage
{
	private static final long serialVersionUID = 1L;

	/**
	* デフォルトの状態でStack100Storageを構築します。
	*/
	public Stack100Storage() {
	}

	/**
	* X軸とY軸の範囲を指定して、Stack100Storageを構築します。
	* @param	xMin	X軸の最小値
	* @param	xMax	X軸の最大値
	* @param	yMin	Y軸の最小値
	* @param	yMax	Y軸の最大値
	*/
	public Stack100Storage( Object xMin, Object xMax, Object yMin, Object yMax ) {
		setXRange( xMin, xMax );
		setYRange( yMin, yMax );
	}

	/**
	* X軸とY軸の範囲を指定して、tackStorageを構築します。
	* @param	xMin	X軸の最小値
	* @param	xMax	X軸の最大値
	* @param	yMin	Y軸の最小値
	* @param	yMax	Y軸の最大値
	*/
	public Stack100Storage( Object xMin, Object xMax, double yMin, double yMax ) {
		setXRange( xMin, xMax );
		setYRange( Double.valueOf( yMin ), Double.valueOf( yMax ));
	}

	/**
	* X軸とY軸の範囲を指定して、Stack100Storageを構築します。
	* @param	xMin	X軸の最小値
	* @param	xMax	X軸の最大値
	* @param	yMin	Y軸の最小値
	* @param	yMax	Y軸の最大値
	*/
	public Stack100Storage( double xMin, double xMax, double yMin, double yMax ) {
		setXRange( Double.valueOf( xMin ), Double.valueOf( xMax ));
		setYRange( Double.valueOf( yMin ), Double.valueOf( yMax ));
	}

	/**
	* 全体の値から算出したY軸の値を算出します。
	* @param	rect	描画する矩形
	* @param	x		X座標オブジェクト
	* @param	y		Y座標オブジェクト
	*/
	public double getYPos ( Rectangle rect, Object x, Object y ) {
		if ( !bInit ) {
			calcTotal();
			bInit = true;
		}
		double total = ((Number )mapSum.get( x )).doubleValue();
		return rect.getHeight()
				- (int )(( ((Number)y).doubleValue() / total ) * rect.getHeight() )
				+ rect.getY();
	}

}

